<?php
defined(page_security_key) or exit;

if (debug && debug_id == $_SESSION['id']){
    ini_set('display_errors', '1');
    ini_set('display_startup_errors', '1');
    error_reporting(E_ALL);  
}

include_once './assets/functions.php';
include_once './settings/settings_redirector.php';

//Check if allowed
$page = 'history';
//Check if allowed
if (isAllowed($page,$_SESSION['profile'],$_SESSION['permission'],'R') === 0){
    header('location: index.php');
    exit;
}
//PAGE Security
$page_manage = 'history_manage';
$update_allowed = isAllowed($page_manage ,$_SESSION['profile'],$_SESSION['permission'],'U');
$delete_allowed = isAllowed($page_manage,$_SESSION['profile'],$_SESSION['permission'],'D');
$create_allowed = isAllowed($page_manage ,$_SESSION['profile'],$_SESSION['permission'],'C');

//GET PARAMETERS
$pagination_page = isset($_GET['p']) ? $_GET['p'] : 1;
$status = isset($_GET['type']) ? '&type='.$_GET['type'] : '';
$search = isset($_GET['search']) ? '&search='.$_GET['search'] : '';

// Determine the URL
$url = 'index.php?page=history&equipmentID='.$_GET['equipmentID'].$status.$search;
//GET Details from URL
$GET_VALUES = urlGETdetails($_GET) ?? '';
//CALL TO API
$api_url = '/v1/history/'.$GET_VALUES;
$responses = ioServer($api_url,'');
//Decode Payload
if (!empty($responses)){$responses = decode_payload($responses);}else{$responses = null;}

//Return QueryTotal from API
$api_url = '/v1/history/'.$GET_VALUES.'&totals=';
$query_total = ioServer($api_url,'');
//Decode Payload
if (!empty($query_total)){$query_total = decode_payload($query_total);}else{$query_total = null;}


// Handle success messages
if (isset($_GET['success_msg'])) {
    if ($_GET['success_msg'] == 1) {
        $success_msg = $message_eq_1;
    }
    if ($_GET['success_msg'] == 2) {
        $success_msg = $message_eq_2;
    }
    if ($_GET['success_msg'] == 3) {
        $success_msg = $message_eq_3;
    }
}

template_header('History','history','view');
$view = '
<div class="content-title">
    <div class="title">
        <i class="fa-solid fa-box-open"></i>
        <div class="txt">
            <h2>'.$history_h2.'</h2>
            <p>'.$history_p.'</p>
        </div>
    </div>
</div>';

if (isset($success_msg)){
    $view .= ' <div class="msg success">
                    <i class="fas fa-check-circle"></i>
                    <p>'.$success_msg.'</p>
                    <i class="fas fa-times"></i>
                </div>';
}
$view .= '
<div class="content-header responsive-flex-column pad-top-5">
        <a href="index.php?page=equipment&equipmentID='.$_GET['equipmentID'].'" class="btn">'.$button_cancel.'</a>
';

$view .= '
    <form action="" method="get">
        <input type="hidden" name="page" value="history">
        <input type="hidden" name="equipmentID" value="'.$_GET['equipmentID'].'">
        <div class="filters">
            <a href="#"><i class="fa-solid fa-filter"></i>'.$general_filters.'</a>
            <div class="list">
            <select name="type">
                <option value="" disabled selected>Type</option>
                <option value="'.$type1.'"'.($status==$type1 ?' selected':'').'>'.$type1.'</option>
                <option value="'.$type2.'"'.($status==$type2 ?' selected':'').'>'.$type2.'</option>
                <option value="'.$type3.'"'.($status==$type3 ?' selected':'').'>'.$type3.'</option>
                <option value="'.$type9.'"'.($status==$type9 ?' selected':'').'>'.$type9.'</option>
                <option value="'.$type14.'"'.($status==$type14 ?' selected':'').'>'.$type14.'</option>
                <option value="'.$type16.'"'.($status==$type16 ?' selected':'').'>'.$type16.'</option>     
                </select>
                <button type="submit">Apply</button>
            </div>
        </div>
        <div class="search">
            <label for="search">
                <input id="search" type="text" name="search" placeholder="'.$history_Search.' " value="" class="responsive-width-100">
                <i class="fas fa-search"></i>
            </label>
        </div>
    </form>
</div>
';
$view .= '
<div class="content-block">
    <div class="table">
        <table class="sortable">
            <thead>
                <tr>
                    <th class="responsive-hidden">'.$history_label1.'</th>
                    <th>'.$history_label2.'</th>
                    <th class="responsive-hidden">'.$history_label3.'</th>
                    <th class="responsive-hidden">'.$history_label4.'</th>
                    <th>'.$history_label5.'</th>';
if ($update_allowed === 1){
    $view .= '       <th>'.$view_asset_actions.'</th>';
}

    $view .= '     </tr>
            </thead>
            <tbody>
            ';

            if (empty($responses)){

                $view .= '
                <tr>
                    <td colspan="8" style="text-align:center;">'.$history_no_history.'</td>
                </tr>';
            } else {

foreach ($responses as $response){

$description = json_decode($response->description) ?? $response->description;
$description = json_encode($description, JSON_PRETTY_PRINT); 

//Replace JSON ITEMS
$search = ['{', '}', '"',':','[',']',','];
$replace   = ['', '','','=','','',''];
$description  = str_replace($search, $replace, $description);

$view .= '<tr>
            <td class="responsive-hidden">'.$response->historyID.'</td>
            <td>'.$response->type.' </td>
            <td class="responsive-hidden">'.$response->created.'</td>
            <td class="responsive-hidden">'.$response->createdby.'</td>
            <td><div style="overflow-y:scroll;height:200px !important;max-width:300px;"><pre>' . $description . '</pre><div></td>
            ';
if ($update_allowed === 1){
    $view .= ' <td><a href="index.php?page=history_manage&equipmentID='.$_GET['equipmentID'].'&rowID='.$response->historyID.'" class="btn_link">'.$general_view .'</a></td>
    ';
}
    $view .= '    
        </tr>
      ';
 }
}

 $view .= ' 
     </tbody>
    </table>
    </div>
</div>
';

$view.='<div class="pagination">';
if ($pagination_page > 1) {
    $page = $pagination_page-1;
    $view .= '<a href="'.$url.'&p=1">'.$general_first.'</a>';
    $view .= '<a href="'.$url.'&p='.$page.'">'.$general_prev.'</a>';
}
$totals = ceil($query_total / $page_rows_history) == 0 ? 1 : ceil($query_total / $page_rows_history);
$view .= '<span> '.$general_page.$pagination_page.$general_page_of.$totals.'</span>';
if ($pagination_page * $page_rows_history < $query_total){
    $page = $pagination_page+1;
    $view .= '<a href="'.$url.'&p='.$page.'">'.$general_next.'</a>';
    $view .= '<a href="'.$url.'&p='.$totals.'">'.$general_last.'</a>';

}

$view .= '</div>';
//OUTPUT
echo $view;

template_footer();
